<?php
// +----------------------------------------------------------------------
// | [KtAdmin] Copyright (c) 2022 [ktadmin.cn] [kt8.cn]
// +----------------------------------------------------------------------
// | KtAdmin is NOT a free software, it under the license terms, visited http://www.kt8.cn/ for more details.
// +----------------------------------------------------------------------

namespace app\cbcrm\controller;

use app\BaseController;
use app\cbcrm\model\manage\DepartmentModel;
use app\cbcrm\model\manage\StaffModel;
use think\facade\Db;
use think\Request;
use think\facade\Session;

class BaseUser extends BaseController
{
    protected $request;
    protected $req;
    protected $user;
    protected $wid;
    protected $token;


    public function  __construct(Request $request){
        $this->request = $request;
        $this->req = $request;
        $this->host  = $request->host();
        $url  = $request->url();
        $this->token = $this->request->header('UserToken');
        $user = Db::table('kt_base_user')->where([['token', '=', $this->token], ['expire_time', '>',time()]])->find();

        if ($user) {
            $user['isSuper'] = 1;
            $user['is_staff'] = 0;
            $this->user = $user;
            $this->wid = $this->user['id'];
            Session::set('wid',$this->user['id']);
            Session::set('uid',$this->user['agid']);
        }else{
            $staff = Db::table('cb_crm_staff')->where([['token', '=', $this->token], ['expire_time', '>',time()]])->find();
            if ($staff) {
                $staff['isSuper'] = 0;
                $staff['is_staff'] = 1;
                $this->user = $staff;
                $this->wid = $staff['wid'];
                Session::set('wid',$this->user['id']);
            }
        }
    }

    /**
     * @title 获取部门下级所有员工
     * @param integer $department_id 部门ID
     * @param integer $staff_id 员工ID/账户ID(wid)
     * @param boolean $self 是否包含自身
     * @param boolean $force 超管是否也进行部门筛选
     * @return array $staffIds
     * */
    public function getDepartmentStaffIds($department_id,$staff_id,$self = true)
    {
        $departmentModel = app()->make(DepartmentModel::class);
        $staffModel = app()->make(StaffModel::class);
        $departmentList = $departmentModel->getList($this->wid);
        $departmentIds = getChildrenIds($department_id,$departmentList);
        // 部门负责人，则包含当前部门的员工
        $departmentInfo = $departmentModel->where('id',$department_id)->field('id,staff_ids')->find();
        if (!$this->user['isSuper'] && $department_id == $this->user['department_id']) {
            if (in_array($staff_id,explode(',',$departmentInfo['staff_ids']))) {
                array_push($departmentIds,$department_id);
            }
        }else{
            array_push($departmentIds,$department_id);
        }
        $staffIds = $staffModel->where('department_id','IN',$departmentIds)->where('status',1)->column('id');

        if ($self) {
            array_push($staffIds, $staff_id);
        }
        return $staffIds;
    }
}
