<?php


namespace app\cbcrm\controller\admin;


use app\cbcrm\controller\BaseAdmin;
use app\cbcrm\model\admin\AuthMenuModel;
use think\Request;

class Menu extends BaseAdmin
{
    protected $model = null;

    public function __construct(Request $request)
    {
        parent::__construct($request);

        $this->model = new AuthMenuModel();
    }

    public function index()
    {
        $list = $this->model->getList();

        $this->success('返回成功',$list);
    }

    public function getTree()
    {
        $all = $this->model->select();
        $tree = getTreeData($all,0);
        $this->success('返回成功',$tree);
    }

    public function add()
    {
        $params = [];
        $params['menu_type'] = $this->request->post('menu_type');
        $params['name'] = $this->request->post('name')?:$this->error('请输入菜单名称');
        $params['path'] = $this->request->post('path')?:$this->error('请填写菜单路径');
        $params['sort'] = $this->request->post('sort',0,'intval');
        $params['status'] = $this->request->post('status',1,'intval');
        $params['parent_id'] = $this->request->post('parent_id',0,'intval');
        $params['action_mark'] = $this->request->post('action_mark','');

        $result = $this->model->saveData($params);

        if ($result) {
            $this->success('添加成功');
        }else{
            $this->error('添加失败');
        }
    }

    public function edit()
    {
        $params = [];
        $params['id'] = $this->request->post('id',0,'intval')?:$this->error('菜单ID参数错误');
        $params['menu_type'] = $this->request->post('menu_type');
        $params['name'] = $this->request->post('name')?:$this->error('请输入菜单名称');
        $params['path'] = $this->request->post('path')?:$this->error('请填写菜单路径');
        $params['sort'] = $this->request->post('sort',0,'intval');
        $params['status'] = $this->request->post('status',1,'intval');
        $params['parent_id'] = $this->request->post('parent_id',0,'intval');
        $params['action_mark'] = $this->request->post('action_mark','');

        $row = $this->model->where('id',$params['id'])->find();

        if (!$row) {
            $this->error('内容未找到');
        }

        $result = $row->save($params);

        if ($result) {
            $this->success('编辑成功');
        }else{
            $this->error('编辑失败');
        }
    }

}
