<?php


namespace app\cbcrm\model\customer;


use think\facade\Db;
use think\Model;
use think\model\concern\SoftDelete;

class OperateModel extends Model
{
    use SoftDelete;

    protected $table = 'cb_crm_operate';

    public function getList($where,$wid)
    {
        $list = $this->withJoin(['customer'],'LEFT')
            ->where($where)
            ->order('id','desc')
            ->paginate(10);
        foreach ($list as $row) {
            if (!$row['is_super']) {
                $row['staff'] = Db::table('cb_crm_staff')->where('wid',$wid)->where('id',$row['staff_id'])->field('id,nickname')->find();
            }else{
                $row['staff'] = null;
            }
        }

        return $list;
    }

    /*
     * 添加操作记录
     * */
    public function addLog($title,$customer_id,$wid,$params = [])
    {
        $data = [
            'wid'=>$wid,
            'customer_id'=>$customer_id,
            'title'=>$title,
            'content'=>json_encode($params,JSON_UNESCAPED_UNICODE),
            'ip'=>request()->ip(),
            'staff_id'=>isset($params['staff_id'])?$params['staff_id']:$wid,
            'is_super'=>isset($params['is_super'])?$params['is_super']:1,
            'create_time'=>date('Y-m-d H:i:s')
        ];
        $this->save($data);
    }

    public function customer()
    {
        return $this->belongsTo(CustomerModel::class,'customer_id','id')->field('id,name');
    }
}
